//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "rot3data.h"
//---------------------------------------------------------------------------
#pragma link "Rot3D"
#pragma link "NumLab"
#pragma resource "*.dfm"
TForm1 *Form1;

double vax, vay;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SBAngXChange(TObject *Sender)
{
Rot3D1->ViewAngleX = SBAngX->Position;
NLabAlpha->Value = SBAngX->Position;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SBAngYChange(TObject *Sender)
{
Rot3D1->ViewAngleY = SBAngY->Position;
NLabBeta->Value = SBAngY->Position;	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SBAngZChange(TObject *Sender)
{
Rot3D1->ViewAngleZ = SBAngZ->Position;
NLabGamma->Value = SBAngZ->Position;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ScrollBar4Change(TObject *Sender)
{
Rot3D1->Magnification = 1-ScrollBar4->Position/100.0;
NumLab4->Value = Rot3D1->Magnification;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
int     i;
double  rx, ry, rz;

Rot3D1->ColorData = clBlue;
for (i=1; i<=100; i++)     /* banana */
  {
  rx = random(300);
  ry = rx + random(50);
  rz = random(30)+(rx+ry)*(rx+ry)/1400;
  Rot3D1->MarkAt (rx,ry,rz,10);
  }
Rot3D1->ColorData = clGreen;
for (i=1; i<=50; i++)
  Rot3D1->MarkAt (200+random(70),100+random(30),200+random(30),12);
Rot3D1->MakeVisible();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Rot3D1MouseMove(TObject *Sender, TShiftState Shift,
	int X, int Y)
{
if (Shift.Contains(ssLeft))
  {
  vax = Rot3D1->ViewAngleX;
  vay = Rot3D1->ViewAngleY;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BButExitClick(TObject *Sender)
{
SBAutoRot->Down = false;
Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RadioButton1Click(TObject *Sender)
{
Rot3D1->BoundBoxStyle = bbNone;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RadioButton2Click(TObject *Sender)
{
Rot3D1->BoundBoxStyle = bbFrame;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RadioButton3Click(TObject *Sender)
{
Rot3D1->BoundBoxStyle = bbFaces;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
Rot3D1->ShowAxes = CheckBox1->Checked;	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SBAxSizeChange(TObject *Sender)
{
Rot3D1->AxSize = SBAxSize->Position;	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Rotate1Click(TObject *Sender)
{
Rot3D1->MouseAction = maRotate;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Zoom1Click(TObject *Sender)
{
Rot3D1->MouseAction = maZoom;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Pan1Click(TObject *Sender)
{
Rot3D1->MouseAction = maPan;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ToClipboard1Click(TObject *Sender)
{
Rot3D1->CopyToClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ToBMPFile1Click(TObject *Sender)
{
SaveDialog1->FileName = "*.bmp";
if (SaveDialog1->Execute())
  Rot3D1->CopyToBMP (SaveDialog1->FileName);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SBBBSizeChange(TObject *Sender)
{
Rot3D1->BoundBoxSize = SBBBSize->Position;	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SBAutoRotClick(TObject *Sender)
{
vax = 0;
vay = 0;
while (SBAutoRot->Down)
  {
  Application->ProcessMessages();
  vax = vax + 1.12;
  if (vax > 360)
    vax = vax-360;
  vay = vay + 1.33;
  if (vay > 360)
    vay = vay - 360;
  Rot3D1->SetViewAngles (vax, vay, 90);
  }
Rot3D1->SetViewAngles (SBAngX->Position, SBAngY->Position, SBAngZ->Position);
}
//---------------------------------------------------------------------------